/* ==========================================================================
        hello5.c
   --------------------------------------------------------------------------
        Copyright (C) 1989.  Daniel J. Reynolds.  All Rights Reserved.
        High Aspect Development Corporation
        9821 South Pulaski Road
        Evergreen Park, IL  60642   312-424-5997
   ========================================================================== */

#include <curses.h>

WINDOW * w1i,* w2i;               /* Global Windows we'll use */

void main(void);
void say_hello(void);

void main() {


WINDOW * w1o,* w2o,* msg;       /* Local Windows we'll use */

    initscr();                  /* Initialize terminal settings and
                                    curses data structures */
    raw();
    noecho();
    curs_set(C_INVISIBLE);      /* Don't need a cursor */
    w1o = newwin(6,14,1,3);     /* Outer Window for border */
    w1i = newwin(4,12,2,4);     /* Inner Window for text */
    w2o = newwin(6,14,1,23);
    w2i = newwin(4,12,2,24);
    msg = newwin(6,80,LINES - 6,0);
    box(w1o,box_typ[BOX_SINGLE].v,box_typ[BOX_SINGLE].h); /* IBM line drawing */
    box(w2o,box_typ[BOX_DOUBLE].v,box_typ[BOX_DOUBLE].h); /* characters */
    wnoutrefresh(w1o);          /* Don't update the terminal until all the */
    wnoutrefresh(w2o);          /* output is ready */
    say_hello();                /* Set up the Sample Windows */
    mvwaddstr(msg,2,3,"overwrite() copies Windows.\n");
    mvwaddstr(msg,3,3,"Press any key to continue.\n");
    box(msg,box_typ[BOX_DOUBLE].v,box_typ[BOX_SINGLE].h);
    wnoutrefresh(msg);
    doupdate();                 /* Now we update & move everything to the */
    wgetch(msg);                /* Screen at once */
    overwrite(w2i,w1i);
    mvwaddstr(msg,2,3,"All characters were copied.\n");
    box(msg,box_typ[BOX_BLOCK].v,box_typ[BOX_BLOCK].h);
    wnoutrefresh(w1i);
    wnoutrefresh(w2i);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    say_hello();
    mvwaddstr(msg,2,3,"overlay() copies Windows, too.\n");
    box(msg,box_typ[BOX_SINGLE].v,box_typ[BOX_DOUBLE].h);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    overlay(w2i,w1i);
    mvwaddstr(msg,2,3,"But overlay() won't copy blank spaces.\n");
    box(msg,box_typ[BOX_HSHADE].v,box_typ[BOX_HSHADE].h);
    wnoutrefresh(w1i);
    wnoutrefresh(w2i);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    say_hello();
    mvwaddstr(msg,2,3,"copywin() allows you to specify the region to copy.\n");
    box(msg,box_typ[BOX_SINGLE].v,box_typ[BOX_SINGLE].h);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    copywin(w2i,w1i,1,0,1,0,1,11,OVERWRITE);
    mvwaddstr(msg,2,3,"Only the line containing \"Hello\" was copied.\n");
    box(msg,box_typ[BOX_HSHADE].v,box_typ[BOX_HSHADE].h);
    wnoutrefresh(w1i);
    wnoutrefresh(w2i);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    say_hello();
    mvwaddstr(msg,2,3,"copywin() can also be used in OVERLAY mode.\n");
    box(msg,box_typ[BOX_DOUBLE].v,box_typ[BOX_DOUBLE].h);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    copywin(w2i,w1i,1,0,1,0,1,11,OVERLAY);
    mvwaddstr(msg,2,3,"Only the word \"Hello\" was copied.\n");
    box(msg,box_typ[BOX_LSHADE].v,box_typ[BOX_LSHADE].h);
    wnoutrefresh(w1i);
    wnoutrefresh(w2i);
    wnoutrefresh(msg);
    doupdate();
    wgetch(msg);
    delwin(w1i);
    delwin(w1o);
    delwin(w2i);
    delwin(w2o);
    delwin(msg);
    curs_set(C_NORMAL);
    doupdate();
    endwin();
}
/* -------------------------------------------------------------------------- */
void say_hello(void) {

    mvwaddstr(w1i,0,0,"............");  /* Put any stuff there */
    mvwaddstr(w1i,1,0,"............");
    mvwaddstr(w1i,2,0,"............");
    mvwaddstr(w1i,3,0,"............");
    wnoutrefresh(w1i);                  /* Update window 1 */
    mvwaddstr(w2i,1,0,"   Hello");      /* Put a nice message */
    mvwaddstr(w2i,2,0,"   World !");
    wnoutrefresh(w2i);                  /* Update window 2 */
}

