#include <curses.h>
#include <signal.h>
#include "hanoi.h"

extern	char *ring[];
void goodbye(int,int,int *);

init_curses()

{
	if (initscr() == ERR) {
		fprintf(stderr, "Sorry, but your terminal isn't powerful enough");
		fprintf(stderr, "to run Hanoi.\nIt lacks some important ");
		fprintf(stderr, "features.");
		exit(1);
	}
	signal(SIGINT, goodbye);
	return;
}

init_pegs(nrings)
int nrings;

{
	for (; nrings > 0; nrings--)
		push(0, nrings);
	return;
}

draw_slab()

{
	move(LINES-2, 0);
	addstr("   ===============[1]==================[2]==================[3]==============");
	move(LINES-3, 0);
	addstr("   ================|====================|====================|===============");
	refresh();
	return;
}

draw_pegs()

{
	int y;

	for (y=LINES-MAX_RINGS-4; y < LINES-3; y++) {
		mvaddch(y, PEG0_COL, '|');
		mvaddch(y, PEG1_COL, '|');
		mvaddch(y, PEG2_COL, '|');
	}
	refresh();
}

draw_rings(nrings)
int nrings;

{
	int y, x;

	y = LINES - 4;
	for (; nrings > 0; nrings--, y--) {
		x = PEG0_COL - nrings;
		mvaddstr(y, x, ring[nrings]);
	}
	refresh();
	return;
}

void goodbye(int a,int b,int * c)

{
	move(LINES-1, 0);
	clrtoeol();
	refresh();
	endwin();
	exit(0);
}


