#include <curses.h>
#include "hanoi.h"

extern	int verbose;

char *ring[] = {
	"0",
	"111",
	"22222",
	"3333333",
	"444444444",
	"55555555555",
	"6666666666666",
	"777777777777777",
	"88888888888888888",
	"9999999999999999999",
	"AAAAAAAAAAAAAAAAAAAAA"
};

static	char blotter[] = "          |          ";

int	pegcol[3] = { PEG0_COL, PEG1_COL, PEG2_COL };

movering(from, to)
int from, to;

{
	static int moveno = 0;
	int ringno, fromheight, toheight, y, x, moveleft, destx, dx, ringsize;
	int pegtop;
	char blotbuf[MAX_RINGS*2+2];

	pegtop = LINES - MAX_RINGS - 5;

	fromheight = peg_height(from);

	/*
	 * Get the number of the ring we gotta move
	 */
	ringno = pop(from);

	toheight = peg_height(to);

	moveno++;
	move(pegtop - 3, pegcol[1] - 1);
	printw("%2d", moveno);

	if (verbose) {
		move(pegtop - 2, pegcol[1] - 7);
		printw("disc %d to peg %d", ringno, to+1);
		refresh();
	}

	/*
	 * From the ring number compute the size of the ring.
	 */
	ringsize = 2 * ringno + 1;

	/*
	 * Center the ring on the peg.
	 */
	x = pegcol[from] - ringno;

	/*
	 * Lift ring from peg
	 */
	strncpy(blotbuf, blotter+(MAX_RINGS-ringno), ringsize);
	blotbuf[ringsize] = '\0';
	for (y=LINES-fromheight-3; y > pegtop; y--) {
		mvaddstr(y, x, blotbuf);
		mvaddstr(y-1, x, ring[ringno]);
		refresh();
	}

	/*
	 * Decide which direction we have to shift the ring.
	 */
	destx = pegcol[to] - ringno;
	moveleft = (x > destx ? 1 : 0);
	dx = (moveleft ? -1 : 1);
	move(pegtop, 0);

	/*
	 * Now shift the ring over to its peg.
	 */
	for (; x != destx; x+=dx) {
		if (moveleft)
			delch();
		else
			insch(' ');
		refresh();
	}

	/*
	 * Slip the ring on the top of the peg
	 */
	move(pegtop, 0);
	clrtoeol();
	y++;
	mvaddstr(y, x, ring[ringno]);
	refresh();

	/*
	 * Now slide the ring the rest of the way down the peg.
	 */
	for (y=pegtop+1; y < LINES - toheight - 4; y++) {
		strncpy(blotbuf, blotter+(MAX_RINGS-ringno), ringsize);
		blotbuf[ringsize] = '\0';
		mvaddstr(y, x, blotbuf);
		mvaddstr(y+1, x, ring[ringno]);
		refresh();
	}

	/*
	 * Update the peg stack to show that the ring has been moved.
	 */
	push(to, ringno);
	return;
}

Light(peg)
int peg;

{
	int ringno, h, x, y;

	push(peg, ringno = pop(peg));
	h = peg_height(peg);
	y = LINES - 3 - h;
	x = pegcol[peg] - ringno;
	move(y, x);
	standout();
	addstr(ring[ringno]);
    standend();
	refresh();
}

Douse(peg)
int peg;

{
	int ringno, h, x, y;

	push(peg, ringno = pop(peg));
	h = peg_height(peg);
	y = LINES - 3 - h;
	x = pegcol[peg] - ringno;
	move(y, x);
    standend();
	addstr(ring[ringno]);
	refresh();
}


